CREATE PROCEDURE CAP_COMPRESSION(IN current_sample_percentage DECIMAL(38,2))
LANGUAGE SQLSCRIPT
AS
BEGIN

TRUNCATE TABLE GT_CAP_LEVEL_1;
TRUNCATE TABLE GT_CAP_LEVEL_2;
TRUNCATE TABLE GT_CAP_LEVEL_3;
TRUNCATE TABLE GT_CAP_LEVEL_4;
TRUNCATE TABLE GT_CAP_LEVEL_5;
TRUNCATE TABLE GT_CAP_LEVEL_5A;
TRUNCATE TABLE GT_CAP_LEVEL_5B;
TRUNCATE TABLE GT_CAP_LEVEL_5C;
TRUNCATE TABLE GT_CAP_LEVEL_6;
-- TRUNCATE TABLE GT_CAP_LEVEL_7;
TRUNCATE TABLE GT_CAP_LEVEL_8;
TRUNCATE TABLE GT_CAP_LEVEL_9;

 
--MESSAGE '1) DELETE CATL_TDS.RESULT_THRESHOLD ' to client DEBUG ONLY;
DELETE FROM CAP_RESULT_THRESHOLD WHERE EXISTS (SELECT 1 FROM CAP_RAW WHERE CAP_RAW.BATTERY_ID=CAP_RESULT_THRESHOLD.BATTERY_ID);
COMMIT;

--MESSAGE '2) INSERT INTO GT_CAP_LEVEL_1 ' to client DEBUG ONLY; -- Calculate S
INSERT INTO GT_CAP_LEVEL_1    
SELECT BATTERY_ID, VT_TIME, Y,
abs(
( LEAD(VT_TIME, 1) OVER(PARTITION BY BATTERY_ID ORDER BY VT_TIME) - LAG(VT_TIME, 1) OVER(PARTITION BY BATTERY_ID ORDER BY VT_TIME) )  *
(Y - LAG(Y, 1) OVER(PARTITION BY BATTERY_ID ORDER BY VT_TIME)) +
((LAG(Y, 1) OVER(PARTITION BY BATTERY_ID ORDER BY VT_TIME)) - LEAD(Y, 1) OVER(PARTITION BY BATTERY_ID ORDER BY VT_TIME)) * 
( VT_TIME  - LAG(VT_TIME, 1) OVER(PARTITION BY BATTERY_ID ORDER BY VT_TIME) )) ABS_s
FROM CAP_RAW ORDER BY 1,2;
COMMIT;

--MESSAGE '3) INSERT INTO GT_CAP_LEVEL_2 ' to client DEBUG ONLY; --Rank S
INSERT INTO GT_CAP_LEVEL_2 
SELECT BATTERY_ID, VT_TIME, Y, ABS_S,  RANK() OVER ( PARTITION BY BATTERY_ID ORDER BY ABS_S DESC )  
FROM GT_CAP_LEVEL_1
ORDER BY BATTERY_ID, VT_TIME;
COMMIT;
TRUNCATE TABLE GT_CAP_LEVEL_1;
COMMIT; 
-- 取点
--MESSAGE '4) INSERT INTO GT_CAP_LEVEL_3 ' to client DEBUG ONLY;   -- This step returns all records - = Column 6
INSERT INTO GT_CAP_LEVEL_3 
(ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N)
SELECT row_number() OVER (PARTITION BY FORCE.BATTERY_ID ORDER BY FORCE.BATTERY_ID), 
FORCE.BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S,
CASE when (ABS_S is null) or ((RANK_S <= TO_INT(:current_sample_percentage*(B.ZIP_RANK_NUMBER-2))) and ABS_S <> 0 )
THEN FORCE.Y 
ELSE null
END
AS SELECTION
FROM GT_CAP_LEVEL_2 FORCE,(SELECT COUNT(1) ZIP_RANK_NUMBER, BATTERY_ID FROM CAP_RAW GROUP BY BATTERY_ID) B --INDEX (IDX_GT_CAP_LEVEL_2_1)
WHERE FORCE.BATTERY_ID=B.BATTERY_ID
ORDER BY FORCE.BATTERY_ID, VT_TIME;
TRUNCATE TABLE GT_CAP_LEVEL_2;
COMMIT; 

--MESSAGE '5) INSERT INTO GT_CAP_LEVEL_4 ' to client DEBUG ONLY; 
INSERT INTO GT_CAP_LEVEL_4 (ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N, PREV_ROW, NEXT_ROW)
SELECT ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N,  K_PREV_ROW_NUM, K_LEAD_ROW_NUM
FROM (
SELECT *,
case when ( FIRST_N IS NULL) AND ( LAG( FIRST_N  , 1) OVER(PARTITION BY BATTERY_ID ORDER BY  VT_TIME) ) IS NOT NULL
THEN LAG( VT_TIME) OVER (PARTITION BY BATTERY_ID ORDER BY VT_TIME ASC ) ELSE NULL END  AS K_PREV_ROW_NUM,
case when ( FIRST_N IS NULL) AND ( LEAD( FIRST_N  , 1) OVER(PARTITION BY BATTERY_ID ORDER BY  VT_TIME) ) IS NOT NULL 
THEN LEAD( VT_TIME) OVER (PARTITION BY BATTERY_ID ORDER BY VT_TIME ASC ) ELSE NULL END AS K_LEAD_ROW_NUM  
FROM GT_CAP_LEVEL_3 ) TEMP_TAB
WHERE FIRST_N IS NULL;
COMMIT;

--MESSAGE '6) INSERT INTO GT_CAP_LEVEL_5 ' to client DEBUG ONLY;
/**  
INSERT INTO GT_CAP_LEVEL_5 (ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N,new_prev_row, new_next_row)
select ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N, 
(case when prev_row is null then LAG( prev_row) OVER (PARTITION BY BATTERY_ID ORDER BY VT_TIME ASC ) else prev_row end) new_prev_row,
(case when next_row is null then lead( next_row) OVER (PARTITION BY BATTERY_ID ORDER BY VT_TIME ASC ) else next_row end) new_next_row
from 
(SELECT *  FROM GT_CAP_LEVEL_4 where prev_row is not NULL 
union 
SELECT *  FROM GT_CAP_LEVEL_4 where next_row is not NULL ) new_tab ;
**/
INSERT INTO GT_CAP_LEVEL_5 (ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N,new_prev_row, new_next_row)
select ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N, 
(case when prev_row is null then LAG( prev_row) OVER (PARTITION BY BATTERY_ID ORDER BY VT_TIME ASC ) else prev_row end) new_prev_row,
(case when next_row is null then lead( next_row) OVER (PARTITION BY BATTERY_ID ORDER BY VT_TIME ASC ) else next_row end) new_next_row
from 
(SELECT *  FROM GT_CAP_LEVEL_4 where prev_row is not NULL OR next_row is not NULL ) new_tab ;
TRUNCATE TABLE GT_CAP_LEVEL_4;
COMMIT;

--MESSAGE '7) INSERT INTO GT_CAP_LEVEL_5A ' to client DEBUG ONLY;  
INSERT INTO GT_CAP_LEVEL_5A (ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N,NEW_PREV_ROW, NEW_NEXT_ROW, 
 NEW_PREV_VT_TIME, NEW_PREV_FIRST_N)
select INX_TAB.ROW_NUM, INX_TAB.BATTERY_ID, INX_TAB.VT_TIME, INX_TAB.Y, INX_TAB.ABS_S, INX_TAB.RANK_S, INX_TAB.FIRST_N, INX_TAB.NEW_PREV_ROW, INX_TAB.NEW_NEXT_ROW, PREV_TAB.VT_TIME , PREV_TAB.FIRST_N
FROM GT_CAP_LEVEL_5 INX_TAB, GT_CAP_LEVEL_3 PREV_TAB--, 
WHERE   INX_TAB.BATTERY_ID = PREV_TAB.BATTERY_ID AND
INX_TAB.NEW_PREV_ROW = PREV_TAB.VT_TIME  ;
COMMIT;

--MESSAGE '8) INSERT INTO GT_CAP_LEVEL_5B ' to client DEBUG ONLY; 
INSERT INTO GT_CAP_LEVEL_5B (ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N,NEW_PREV_ROW, NEW_NEXT_ROW,
 NEW_PREV_VT_TIME, NEW_PREV_FIRST_N, NEW_NEXT_VT_TIME, NEW_NEXT_FIRST_N)
select INX_TAB.ROW_NUM, INX_TAB.BATTERY_ID, INX_TAB.VT_TIME, INX_TAB.Y, INX_TAB.ABS_S, INX_TAB.RANK_S, INX_TAB.FIRST_N, INX_TAB.NEW_PREV_ROW, INX_TAB.NEW_NEXT_ROW, INX_TAB.NEW_PREV_VT_TIME, INX_TAB.NEW_PREV_FIRST_N, NEXT_TAB.VT_TIME , NEXT_TAB.FIRST_N
FROM  GT_CAP_LEVEL_5A INX_TAB, GT_CAP_LEVEL_3 NEXT_TAB
WHERE   INX_TAB.BATTERY_ID = NEXT_TAB.BATTERY_ID AND 
INX_TAB.NEW_NEXT_ROW = NEXT_TAB.VT_TIME;
TRUNCATE TABLE GT_CAP_LEVEL_5A;
COMMIT;
-- 取最近的点
INSERT INTO GT_CAP_LEVEL_5C 
select GT_TAB3.VT_TIME,  GT_TAB3.BATTERY_ID, MAX(INX_TAB.VT_TIME)
  FROM GT_CAP_LEVEL_3 GT_TAB3 ,GT_CAP_LEVEL_5B INX_TAB
WHERE GT_TAB3.FIRST_N IS NULL AND INX_TAB.VT_TIME <=  GT_TAB3.VT_TIME AND INX_TAB.BATTERY_ID=GT_TAB3.BATTERY_ID
GROUP BY GT_TAB3.BATTERY_ID, GT_TAB3.VT_TIME ;

COMMIT;

-- FIND K, B
--MESSAGE '9) INSERT INTO GT_CAP_LEVEL_6 ' to client DEBUG ONLY; 
INSERT INTO GT_CAP_LEVEL_6
SELECT  
GT_TAB3.ROW_NUM, GT_TAB3.BATTERY_ID, GT_TAB3.VT_TIME, GT_TAB3.Y, GT_TAB3.ABS_S, GT_TAB3.RANK_S, GT_TAB3.FIRST_N, 
(INX_TAB.new_PREV_FIRST_N - INX_TAB.new_NEXT_FIRST_N)/(INX_TAB.new_PREV_VT_TIME-INX_TAB.new_NEXT_VT_TIME)  AS K , 
(INX_TAB.new_PREV_FIRST_N - ((INX_TAB.new_PREV_FIRST_N - INX_TAB.new_NEXT_FIRST_N)/(INX_TAB.new_PREV_VT_TIME-INX_TAB.new_NEXT_VT_TIME) * INX_TAB.new_PREV_VT_TIME))  AS B,
INX_TAB.ROW_NUM AS INX_ROW_NUM, INX_TAB.NEW_PREV_ROW,  INX_TAB.new_PREV_VT_TIME, INX_TAB.new_PREV_FIRST_N,
INX_TAB.NEW_NEXT_ROW, INX_TAB.new_NEXT_VT_TIME, INX_TAB.new_NEXT_FIRST_N
FROM GT_CAP_LEVEL_3 GT_TAB3 ,GT_CAP_LEVEL_5B INX_TAB, GT_CAP_LEVEL_5C LEVEL_5C_TAB
WHERE GT_TAB3.FIRST_N IS NULL 
AND GT_TAB3.BATTERY_ID=LEVEL_5C_TAB.BATTERY_ID AND GT_TAB3.VT_TIME=LEVEL_5C_TAB.ROW_NUM 
AND INX_TAB.BATTERY_ID=LEVEL_5C_TAB.BATTERY_ID AND INX_TAB.VT_TIME=LEVEL_5C_TAB.INX_ROW_NUM ;

TRUNCATE TABLE GT_CAP_LEVEL_5C;
COMMIT;
TRUNCATE TABLE GT_CAP_LEVEL_5B;
COMMIT;



-- FIND 拟合电压y'    NEW_CAL_Y 
--MESSAGE '10) INSERT INTO GT_CAP_LEVEL_8 ' to client DEBUG ONLY;
/**
INSERT INTO GT_CAP_LEVEL_8 (ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N, K, B, CAL_MISSING, NEW_CAL_Y)
SELECT ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N, K, B, VT_TIME * K + B, VT_TIME * K + B AS NEW_CAL_Y FROM GT_CAP_LEVEL_6
UNION ALL
SELECT ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N, NULL, NULL, NULL, FIRST_N AS NEW_CAL_Y FROM GT_CAP_LEVEL_3
WHERE FIRST_N IS NOT NULL
ORDER BY 2, 1 ASC;
**/

INSERT INTO GT_CAP_LEVEL_8 (ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N, K, B, CAL_MISSING, NEW_CAL_Y)
SELECT ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N, K, B, VT_TIME * K + B, VT_TIME * K + B AS NEW_CAL_Y FROM GT_CAP_LEVEL_6
;
INSERT INTO GT_CAP_LEVEL_8 (ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N, K, B, CAL_MISSING, NEW_CAL_Y)
SELECT ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N, NULL, NULL, NULL, FIRST_N AS NEW_CAL_Y FROM GT_CAP_LEVEL_3
WHERE FIRST_N IS NOT NULL;

TRUNCATE TABLE GT_CAP_LEVEL_6;
COMMIT;
TRUNCATE TABLE GT_CAP_LEVEL_3;
COMMIT;

-- FIND MEANS
--MESSAGE '11) INSERT INTO GT_CAP_LEVEL_9 ' to client DEBUG ONLY;
INSERT INTO GT_CAP_LEVEL_9 
SELECT ROW_NUM, BATTERY_ID, VT_TIME,Y,ABS_S,RANK_S,FIRST_N,K,B,CAL_MISSING,NEW_CAL_Y, avg(Y) OVER (PARTITION BY BATTERY_ID ORDER BY BATTERY_ID ASC ) AS MEAN_Y 
, POWER(Y- NEW_CAL_Y,2) AS Y_MINUS_Y_SQR, POWER(Y-(avg(Y) OVER (PARTITION BY BATTERY_ID ORDER BY BATTERY_ID ASC )),2) AS Y_MINUS_Y_Y_SQR 
FROM GT_CAP_LEVEL_8   
ORDER BY BATTERY_ID, ROW_NUM;
TRUNCATE TABLE GT_CAP_LEVEL_8;
COMMIT;

-- FIND THRESHOLD CAPTAGE
--MESSAGE '12) INSERT INTO RESULT_THRESHOLD ' to client DEBUG ONLY;
INSERT INTO CAP_RESULT_THRESHOLD
SELECT BATTERY_ID, case when SUM(Y_MINUS_Y_Y_SQR)=0 then 1 else (1 - SQRT(SUM(Y_MINUS_Y_SQR)  / SUM(Y_MINUS_Y_Y_SQR)) ) end AS R_SQRT
FROM  GT_CAP_LEVEL_9
GROUP BY BATTERY_ID
ORDER BY BATTERY_ID;

commit;
end ;